#ifndef RTS_SCALAR_SLICE
#define RTS_SCALAR_SLICE

#include "dataTypes.h"
#include "colormap.h"

struct scalarslice
{
	//gpu pointer to the scalar slice
	ptype* S;

	//resolution of the slice
	int R[2];

    scalarslice();
	scalarslice(int x, int y);
	~scalarslice();
	void clear();

	void toImage(std::string filename, ptype vmin, ptype vmax, rts::colormap::colormapType cmap = rts::colormap::cmBrewer);
	void toImage(std::string filename, bool positive = true, rts::colormap::colormapType cmap = rts::colormap::cmBrewer);
	void toEnvi(std::string filename, ptype wavelength = 0, bool append = false);

};



#endif
